from shuffle import shuffle
from initial_probs import initial_probs
from find_worst import find_worst
import random


def simulate_shuffle(n_voters, n_attackers=0, rounds=1):
	owners = list (range (n_voters))
	attackers = [True]*n_attackers + [False]*(n_voters-n_attackers)
	v = initial_probs (n_voters)

	worst = []
	for n in range (rounds):
		# randomize order
		r = random.sample (range(n_voters), n_voters)
		owners = [owners[n] for n in r]
		attackers = [attackers[n] for n in r]
		v = [v[n] for n in r]
		# shuffle
		v, owners = shuffle (v, owners, attackers)
		# worst
		worst += [find_worst (v, n_attackers)]

	return worst


if __name__ == '__main__':
	n_voters = 8
	n_attackers = 4
	rounds = 10

	w = simulate_shuffle (n_voters, n_attackers, rounds)
	print ('# worst per round')
	print (w)
